Bug 462689 - glibc double-free in systemtap test case
glibc double-free in systemtap test case
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: elfutils (Show other bugs)
5.3
All Linux
medium Severity medium
: rc
: ---
Assigned To: Roland McGrath
: Regression
Depends On:
Blocks: 253156
  Show dependency treegraph
 
Reported: 2008-09-18 06:44 EDT by Frank Ch. Eigler
Modified: 2009-01-20 16:08 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-20 16:08:12 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
libdwfl fix (1.90 KB, patch)
2008-09-30 02:41 EDT, Roland McGrath
no flags Details | Diff

  None (edit)
Description Frank Ch. Eigler 2008-09-18 06:44:51 EDT
elfutils-0.137, as built for rhel5.3, appears to cause a glibc double-free
error on i386 on the systemtap (git) test case.  This occurs with a build
either with rhel5.3-track elfutils* rpms installed, and also with a
systemtap --with-elfutils bundled build.  The error does not appear for
elfutils 0.135 (in bundled mode).

    stap -p4 ..../testsuite/buildok/seventeen.stp

*** glibc detected *** ./stap: corrupted double-linked list: 0x0a81c8c8 ***
======= Backtrace: =========
/lib/libc.so.6[0xb9b186]
/lib/libc.so.6[0xb9cd6d]
/lib/libc.so.6[0xb9f181]
/lib/libc.so.6(realloc+0x19d)[0xba032d]
/home/fche/DEVEL/BUILD2/../INST2/lib/systemtap/libdw.so.1[0xdf9592]
/home/fche/DEVEL/BUILD2/../INST2/lib/systemtap/libdw.so.1(dwfl_addrsegment+0x231)[0xdf9bc1]
/home/fche/DEVEL/BUILD2/../INST2/lib/systemtap/libdw.so.1(dwfl_addrmodule+0x31)[0xdff561]
./stap[0x777819]
./stap(_ZN6dwflpp18loc2c_emit_addressEPvP7obstacky+0x3d)[0x777f6d]
./stap[0x78f9c9]
./stap[0x791cf0]
./stap[0x77c4b9]
Comment 1 Roland McGrath 2008-09-30 02:41:30 EDT
Created attachment 318043 [details]
libdwfl fix

I'm putting this fix upstream.  Please verify it works for you.
Comment 2 Mark Wielaard 2008-10-01 09:40:27 EDT
With that patch it doesn't crash and burn anymore, which is definitely progress.

But the systemtap test still fails:
semantic error: libdwfl failure (dwfl_addrmodule): no error: identifier '$write_fifo_fops' at /home/mark/src/systemtap/testsuite/buildok/seventeen.stp:11:19

This might be a different issue though. The test did PASS with the 0.135 elfutils and systemtap from fedora 9.
Comment 3 Mark Wielaard 2008-10-01 10:25:37 EDT
The no error in that semantic error message is somewhat weird. dwfl_addrmodule returns NULL but doesn't set dwfl_errno.
Comment 4 Mark Wielaard 2008-10-01 14:30:53 EDT
Roland pointed out that I should also apply the elfutils-0.137-fixes.patch from the elfutils-0.137-2.fc9 rpm. Combined these patches plus the libdwfl fix from comment #1 make that test PASS!
Comment 7 Masami Hiramatsu 2008-10-06 20:16:30 EDT
is this truly fixed on rhel5.3?
Comment 8 Petr Muller 2008-10-13 04:42:50 EDT
not yet, respin was requested, but not yet done as far as I know
Comment 9 Roland McGrath 2008-10-13 15:00:58 EDT
built a while back, but forgot erratum respin magic hooey until today
Comment 14 errata-xmlrpc 2009-01-20 16:08:12 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2009-0214.html

Note You need to log in before you can comment on or make changes to this bug.